# class Byebug::ConditionCommand

Implements conditions on breakpoints.

Adds the ability to stop on breakpoints only under certain conditions.

### Public Class Methods

description() click to toggle source

    # File lib/byebug/commands/condition.rb, line 21
        def self.description
          <<-DESCRIPTION
            cond[ition] <n>[ expr]

            #{short_description}

            Specify breakpoint number <n> to break only if <expr> is true. <n> is
            an integer and <expr> is an expression to be evaluated whenever
            breakpoint <n> is reached. If no expression is specified, the condition
            is removed.
          DESCRIPTION
        end

regexp() click to toggle source

    # File lib/byebug/commands/condition.rb, line 17
    def self.regexp
      /^\s* cond(?:ition)? (?:\s+(\d+)(?:\s+(.*))?)? \s*$/x
    end

short_description() click to toggle source

    # File lib/byebug/commands/condition.rb, line 34
    def self.short_description
      "Sets conditions on breakpoints"
    end

### Public Instance Methods

execute() click to toggle source

    # File lib/byebug/commands/condition.rb, line 38
    def execute
      return puts(help) unless @match[1]

      breakpoints = Byebug.breakpoints.sort_by(&:id)
      return errmsg(pr("condition.errors.no_breakpoints")) if breakpoints.empty?

      pos, err = get_int(@match[1], "Condition", 1)
      return errmsg(err) if err

      breakpoint = breakpoints.find { |b| b.id == pos }
      return errmsg(pr("break.errors.no_breakpoint")) unless breakpoint

      return errmsg(pr("break.errors.not_changed", expr: @match[2])) unless syntax_valid?(@match[2])

      breakpoint.expr = @match[2]
    end